!Presente
program Corrige_Presente_Grads
implicit none
integer,parameter:: filmod=4                                                    !arq. modelo
integer,parameter:: filobs=2                                                    !arq. observado
integer,parameter:: filcor=3                                                    !arq. modelo corrigido
integer,parameter:: filpix=5                                                    !arq. resultados por pixel    
integer,parameter:: anomodi=1970 ,anomodf=2000                                  !intervalo anos mod presente 
integer,parameter:: anoobsi=1981 ,anoobsf=2016                                  !intervalo anos obs 
integer,parameter:: ncell=10400                                                !numero de pxels do arq grads 
integer,parameter:: nanosobs=anoobsf-anoobsi+1                                  !n total de anos obs
integer,parameter:: nanosmod=anomodf-anomodi+1                                  !n total de anos mod clima presente
real,allocatable:: vardiamod(:,:)                                               !matriz var diaria mod presente
real,allocatable:: vardiaobs(:,:)                                               !matriz var diaria obs
real,allocatable:: vardiacor(:,:)                                               !matriz var diaria corrigida  
real,allocatable:: varmesmod(:,:)                                               !mensais mod presente 
real,allocatable:: varmesobs(:,:),varmescor(:,:)                                !mensais observadas e corrigidas
real,allocatable:: freqobs(:)                                                   !frequencias experimentais
real,allocatable:: auxmod(:),auxobs(:)                                          !variaveis auxiliares
integer,allocatable:: sortmod(:),sortobs(:),ipos(:)                             !vetores que ordenam de menor para maior
integer:: nvalobs(12),nvalmod(12)                                               !n total valores de var para cada mes  
integer:: i,npos,idia,imes,iano,idia1,idia2,icdf,icdfmod,ifreq,icell,diasmes(12),ncdfaux,pixel,iseed
real:: freq,freqmod1,undefmod,undef,ran1,avermod,avercor,averobs
data diasmes/31,28,31,30,31,30,31,31,30,31,30,31/
character climames*1,histo*1, dirinobs*100,dirinmod*100, dirout*100
character cdia*2,cmes*2,cano*4,jmes*3
character cvarmod*22,cvarobs*32
!diretorio de entrada e saida de dados
dirinobs = '/stornext/online11/eta/Priscila/PSTP/CHIRPS/recorte/'
dirinmod = '/stornext/online16/etamc/argos_STP/minella/correcoes_Eta/ETA/Historico/PREC/'
dirout = '/stornext/online16/etamc/argos_STP/minella/correcoes_Eta/ETA_corr_CHIRPS/PREC/Historico/teste/'
cvarmod='Eta_cpteta20_4km_PREC'
cvarobs='chirps-v2.0_GradeEta'
pixel=3839
iseed=1
undef=-9999.
    
!    write(*,*)'*****  Digite s ou n  *****'
!    write(*,*)
!    write(*,*)'Deseja gerar climatologias mensais(PREC)? '
!    read(*,'(A1)')climames    
!    write(*,*)
!    write(*,*)'Deseja gerar historicos mensais(PREC)? '
!    read(*,'(A1)')histo    
!    write(*,*)

climames='s'
histo='n'

if(pixel > 0) then
   open(filpix,file=''//trim(dirout)//'CDF.txt',form='formatted',status='unknown') 
   write(filpix,'(a28,i5)') 'Medias CDF modelo para pixel',pixel
endif 
 
! variaveis modelo clima presente
allocate(vardiamod(nanosmod*31,ncell))
allocate(varmesmod(nanosmod*12,ncell))

! observacoes periodo historico
allocate(varmesobs(nanosobs*12,ncell))
allocate(vardiaobs(nanosobs*31,ncell))

! variaveis corrigidas
allocate(varmescor(nanosmod*12,ncell))
allocate(vardiacor(nanosmod*31,ncell))

varmesobs=0
nvalobs=0
varmesmod=0.
nvalmod=0
varmescor=0.

allocate(sortmod(nanosmod*31))
allocate(sortobs(nanosobs*31))
allocate(auxmod(nanosmod*31))
allocate(auxobs(nanosobs*31))
allocate(freqobs(nanosobs*31))

do imes=1,12

    print*,'processando mes ',imes

    idia1=0
    do iano=1,nanosmod
		 idia1=nvalmod(imes)+1
		 nvalmod(imes)=nvalmod(imes)+diasmes(imes)
	    if(mod(anomodi+iano-1,4) == 0 .and. imes == 2) nvalmod(imes)=nvalmod(imes)+1
		!nvalmod(imes)=nvalmod(imes)+30 ! meses de 30 dias no modelo	
		do idia=idia1,nvalmod(imes)
            write(cdia,'(I2.2)')idia-idia1+1		        
            write(cmes,'(I2.2)')imes    
            write(cano,'(I4)') anomodi+iano-1	
												
!     if (imes==1) jmes='jan'
!		   if (imes==2) jmes='feb'
!		   if (imes==3) jmes='mar'
!		   if (imes==4) jmes='apr'
!		   if (imes==5) jmes='may'
!			  if (imes==6) jmes='jun'
!			  if (imes==7) jmes='jul'
!			  if (imes==8) jmes='aug'
!			  if (imes==9) jmes='sep'
!			  if (imes==10) jmes='oct'
!			  if (imes==11) jmes='nov'
!			  if (imes==12) jmes='dec'
												
												
																					
												
      								
													
            !abre arq.com variavel diaria modelo
            !open(filmod,file=''//trim(dirinmod)//trim(cvarmod)//'_'//cdia//cmes//cano//'.bin',form='unformatted',status='old',recordtype='stream')
												!open(filobs,file=''//trim(dirinobs)//trim(cvarobs)//'_'//cdia//jmes//cano//'.bin',form='unformatted',status='old',recordtype='stream') !para cmorph
												open(filmod,file=''//trim(dirinmod)//trim(cvarmod)//'_'//cano//cmes//cdia//'.bin',form='unformatted',status='old',access='stream')      !para chirps
			read(filmod) (vardiamod(idia,icell),icell=1,ncell)
			close(filmod)
			do icell=1,ncell
			    varmesmod((iano-1)*12+imes,icell)=varmesmod((iano-1)*12+imes,icell)+vardiamod(idia,icell)
			enddo
		enddo
	enddo

    idia1=0
    do iano=1,nanosobs
        idia1=nvalobs(imes)+1
	    nvalobs(imes)=nvalobs(imes)+diasmes(imes)
	    if(mod(anoobsi+iano-1,4) == 0 .and. imes == 2) nvalobs(imes)=nvalobs(imes)+1
	    do idia=idia1,nvalobs(imes)
            write(cdia,'(I2.2)')idia-idia1+1		        
            write(cmes,'(I2.2)')imes    
            write(cano,'(I4)')anoobsi+iano-1
            !abre arq. com variavel diaria observada
            !open(filobs,file=''//trim(dirinobs)//trim(cvarobs)//'_'//cdia//cmes//cano//'.bin',form='unformatted',status='old',recordtype='stream')
												 open(filobs,file=''//trim(dirinobs)//trim(cvarobs)//'_'//cano//cmes//cdia//'.bin',form='unformatted',status='old',access='stream')
		    read(filobs) (vardiaobs(idia,icell),icell=1,ncell)
		    close(filobs)
		    do icell=1,ncell
			    varmesobs((iano-1)*12+imes,icell)=varmesobs((iano-1)*12+imes,icell)+vardiaobs(idia,icell)
		    enddo
	    enddo
    enddo

    if(imes == 1) then
        ! determina os pixels com undef do modelo e da observacao
        allocate(ipos(ncell))
        ipos=0
        npos=0
        do icell=1,ncell
            !if(vardiamod(1,1,icell) /= undefmod) then ! nao eh undef do modelo
            if(vardiamod(1,icell) >= -100.) then ! nao eh undef do modelo    
                if(vardiaobs(1,icell) > -100.) then ! nao eh undef na observacao
                    npos=npos+1
                    ipos(npos)=icell
                    vardiacor(:,icell)=undef
                endif        
            endif
        enddo
    endif

    do i=1,npos  
        icell=ipos(i)
        
!       Gera cdf do modelo 
        do idia=1,nvalmod(imes)
		    auxmod(idia)=vardiamod(idia,icell)
	    enddo
        call SORTRX(nvalmod(imes),auxmod,sortmod)
        icdfmod=0           
        do idia=1,nvalmod(imes)
            if(vardiamod(sortmod(idia),icell) > 0.) then
                icdfmod=idia
                freqmod1=float(idia)/(float(nvalmod(imes))+1)
                exit
            endif
        enddo

!       cdf observado
        
        do idia=1,nvalobs(imes)
		    auxobs(idia)=vardiaobs(idia,icell)
		       
!		    if(vardiaobs(idia,icell)< 5.) then
!		    print*,vardiaobs(idia,icell),idia,icell
!		    pause
!		    endif
    
	    enddo
        call SORTRX(nvalobs(imes),auxobs,sortobs)
        freqobs=0.
        icdf=0
        do idia=1,nvalobs(imes)
            if(vardiaobs(sortobs(idia),icell) > 0.) then
                icdf=idia
                do ifreq=icdf,nvalobs(imes)
                    freqobs(ifreq)=float(ifreq)/(float(nvalobs(imes))+1)
                enddo
                exit
            endif
        enddo
        
!       corrige variuavel do modelo
        
        do idia=1,nvalmod(imes)
	        if(vardiamod(sortmod(idia),icell) <= 0)then		             
		        freq = ran1(iseed)*freqmod1
		    else
		        freq = float(idia)/(float(nvalmod(imes))+1)
		    endif
	        if(freq < freqobs(icdf))then ! assume o menor valor observado
	    	    vardiacor(sortmod(idia),icell)= vardiaobs(sortobs(1),icell)            
	        else
	    	    vardiacor(sortmod(idia),icell)= vardiaobs(sortobs(nvalobs(imes)),icell)  
	    	    do ifreq=icdf+1,nvalobs(imes)
	    		    if(freq < freqobs(ifreq))then
    	    		    vardiacor(sortmod(idia),icell)= vardiaobs(sortobs(ifreq-1),icell)+(freq-freqobs(ifreq-1))* &
	        		    & (vardiaobs(sortobs(ifreq),icell)-vardiaobs(sortobs(ifreq-1),icell))/(freqobs(ifreq)-freqobs(ifreq-1))
		       		    exit
		    	    endif
		   	    enddo
	        endif
        enddo
    
        if(pixel == icell) then ! escreve cdfs do pixel
            
            write(filpix,'(a5,i5)') 'Mes ',imes        
            write(filpix,'(a50)') '       nao corrigida corrigida           observada'  
            write(filpix,'(a50)') '         F       Var       Var         F       Var'
            write(filpix,*)              
            if((nvalobs(imes)-icdf) < (nvalmod(imes)-icdfmod)) then
                write(filpix,'(f10.2,2f10.3,f10.2,f10.3)') (100*float(icdfmod+ifreq-1)/(float(nvalmod(imes)+1)),vardiamod(sortmod(ifreq),pixel), &
                                       & vardiacor(sortmod(ifreq),pixel),100*freqobs(ifreq),vardiaobs(sortobs(ifreq),pixel),ifreq=1,nvalobs(imes)-icdf)
                write(filpix,'(f10.2,2f10.3)') (100*float(icdfmod+ifreq-1)/(float(nvalmod(imes)+1)),vardiamod(sortmod(ifreq),pixel), &
                                       & vardiacor(sortmod(ifreq),pixel),ifreq=nvalobs(imes)-icdf+1,nvalmod(imes)-icdfmod)
            else
                write(filpix,'(f10.2,2f10.3,f10.2,f10.3)') (100*float(icdfmod+ifreq-1)/(float(nvalmod(imes)+1)),vardiamod(sortmod(ifreq),pixel), &
                                       & vardiacor(sortmod(ifreq),pixel),100*freqobs(ifreq),vardiaobs(sortobs(ifreq),pixel),ifreq=1,nvalmod(imes)-icdfmod)
                write(filpix,'(30x,f10.2,f10.3)') (100*freqobs(ifreq),vardiaobs(sortobs(ifreq),pixel),ifreq=nvalmod(imes)-icdfmod+1,nvalobs(imes)-icdf)            
            endif
            
            averobs=sum(vardiaobs(1:nvalobs(imes),pixel))/float(nvalobs(imes))
            avermod=sum(vardiamod(1:nvalmod(imes),pixel))/float(nvalmod(imes))
            avercor=sum(vardiacor(1:nvalmod(imes),pixel))/float(nvalmod(imes))            
            
            write(filpix,*)
            write(filpix,'(a10,2f10.3,10x,f10.3)') 'Media     ',avermod,avercor,averobs
            write(filpix,*)  
            
        endif

    enddo
    
    !Gera valores mensais corrigidos_________________________________________________________

	do idia=1,nvalmod(imes)
		!idia1=int((idia-1)/30)*12+imes
		idia1=int((idia-1)/diasmes(imes))*12+imes
		do i=1,npos
		    icell=ipos(i)
			varmescor(idia1,icell)=varmescor(idia1,icell)+vardiacor(idia,icell)
		enddo
	enddo    

    ! imprime valores do mes
    idia2=0
    do iano=1,nanosmod
        idia1=idia2+1
								
								idia2=idia2+diasmes(imes)
								if(mod(anomodi+iano-1,4) == 0 .and. imes == 2) idia2=idia2+1  
        !idia2=idia2+30  
        do idia=idia1,idia2
            write(cdia,'(I2.2)')idia-idia1+1		        
            write(cmes,'(I2.2)')imes    
            write(cano,'(I4)')anomodi+iano-1 
            !abre arquivo de valores diarios
            open(filcor,file=''//trim(dirout)//trim(cvarmod)//'_corr_'//cdia//cmes//cano//'.bin',form='unformatted',status='unknown',access='stream')
            write(filcor) (vardiacor(idia,icell),icell=1,ncell)
            close(filcor)
        enddo
    enddo

enddo ! fim loop mes

close(filpix)
deallocate(sortmod,sortobs)
deallocate(freqobs)
deallocate(auxmod,auxobs)
deallocate(vardiaobs,vardiamod,vardiacor)


! agora calcula valores medios diarios quando nao eh prec

!if(cvarobs /= 'prec') then ! nao eh precipitacao calcula media diaria
!    varmesmod=varmesmod/30.
 !   varmescor=varmescor/30.
 !   do iano=1,nanosobs
	 !   do imes=1,12
  !          idia1=diasmes(imes)
	 !       if(mod(anoobsi+iano-1,4) == 0 .and. imes == 2) idia1=idia1+1
		!	varmesobs((iano-1)*12+imes,:)=varmesobs((iano-1)*12+imes,:)/float(idia1)
		!enddo
  !  enddo    
!endif


!Gera arq. climatologia mensal---------------------------------------------------    
if(climames == 's')then
    write(*,*)'Gerando climatologias...'
    call climatologia(varmescor,varmesmod,nanosmod,nanosobs,varmesobs,ncell,dirout,anomodi,anomodf,anoobsi,anoobsf,cvarobs,ipos,npos) 
endif
!-------------------------------------------------------------------------------

!Gera serie historica mensal**************************************************    
if(histo == 's')then
    write(*,*)'Gerando series historicas mensais'
    call historico(varmescor,varmesmod,varmesobs,nanosmod,nanosobs,ncell,dirout,anomodi,anomodf,anoobsi,anoobsf,cvarobs,ipos,npos)
endif
!******************************************************************************    
deallocate(varmesmod)    
deallocate(varmescor)
deallocate(varmesobs)
write(*,*)
write(*,*)'Programa terminou'
write(*,*)

stop
end
!FIM PROGRAMA
  
real function ran1(idum)
    implicit real (a-h,o-z)
    !INTEGER*8 IA,IM,IQ,IR,NTAB,NDIV
    !INTEGER IDUM
    !REAL*8 AM,EPS,RNMX
    PARAMETER (IA=16807,IM=2147483647,AM=1./IM,IQ=127773,IR=2836,NTAB=32,NDIV=1+(IM-1)/NTAB,EPS=1.2e-7,RNMX=1.-EPS)
    !INTEGER*8 j,k,iv(NTAB),iy
    DIMENSION iv(NTAB)
    SAVE iv,iy
    DATA iv /NTAB*0/, iy /0/
    if (idum.le.0.or.iy.eq.0) then
        idum=max(-idum,1)
        do j=NTAB+8,1,-1
            k=idum/IQ
            idum=IA*(idum-k*IQ)-IR*k
            if (idum.lt.0) idum=idum+IM
            if (j.le.NTAB) iv(j)=idum
        enddo
        iy=iv(1)
    endif
    k=idum/IQ
    idum=IA*(idum-k*IQ)-IR*k
    if (idum.lt.0) idum=idum+IM
    j=1+iy/NDIV
    iy=iv(j)
    iv(j)=idum
    ran1=min(AM*iy,RNMX)
    return
END function ran1    
